=== debian/changelog ===
gnucash (1:3.10-1~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * debian/control: switch gnucash's recommended packages to dependencies.
  * Note that the Debian packagers added at least four, maybe five patches to
    fix various FTBFS on 3.10, but forgot to mention that in the changelog.
  * debian/rules: disable build with "-Wno-error=stringop-truncation" to fix
    FTBFS with GCC-6.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 15 Apr 2020 09:59:23 -0700

gnucash (1:3.10-1) unstable; urgency=medium

  * New upstream release.

  [ Micha Lenk ]
  * debian/rules: Stop using the aqbanking debhelper.
    Due to some package re-organization done in libaqbanking 5.99.40beta-1
    this debhelper extension isn't needed anymore.

  [ Dmitry Smirnov ]
  * Rules-Requires-Root: no.
  * Standards-Version: 4.5.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 12 Apr 2020 14:27:01 +1000
